#!/usr/local/bin/perl
# -*- coding: utf-8 -*-

use strict;
use Env qw(ESTWORD);
use open IN => ":utf8";

my @a = (
    [ "蛸", "鮹", "鱆", "章魚" ],
    [ "醗酵", "発酵", ],
    [ "百鬼園", "百閒", ],
    [ "函数", "関数", ],
    [ "涩", "渋", "澀", "澁", ],
    [ "間", "间", "閒", ],
    [ "斋", "斎", "齋", ],
    [ "关", "關", "闗", "関", ],
    [ "凾", "函", ],
    [ "数", "數", "數", ],
    [ "发", "発", "發", ],
    [ "酦", "醗", "醱", ],
    [ "畑", "畠", "𤳉", ],
    );

my @e = ( $ESTWORD );

foreach my $aj (@a) {
    my @f;
    foreach my $k (@e) {
	my @n = u_split($k, @{$aj});
	if($#n > 1) {
	    my $d = $#n;
	    my @b = cardasian_product($d, @{$aj});
	    foreach my $i (0 .. $#b) {
		my $t = '';
		foreach my $j (0 .. $d-1) {
		    $t = $t . $n[$j] . $b[$i][$j];
		}
		$t = $t . $n[$d];
		if ($t !~ /$k/) {
		    push(@f, $t);
		}
	    }
	} elsif ($#n == 1) {
	    foreach my $m (@{$aj}) {
		my $t = join($m, @n);
		if ($t !~ /$k/) {
		    push(@f, $t);
		}
	    }
	}
    }
    push(@e, @f);
}

printcand(@e);

sub u_split {
    my ($a, @b) = @_;
    my $d = join('|', @b);
    if ($a =~ /$d/) { 
	my @c = split(/($d)/, $a);
	foreach my $i (0 .. $#c) {
	    if ($c[$i] =~ /$d/) {
		if($i<$#c) {
		    splice(@c, $i, 1);
		} else {
		    $c[$i] = "";
		}
	    }
	}
	return @c;
    } else {
	return ();
    }
}

sub cardasian_product {
    my ($a, @b) = @_;
    my $d = $#b + 1;
    my $n = ($d ** $a);
    my @c;
    foreach my $i (0 .. $n-1) {
	my @e;
	foreach my $j (0 .. $a-1) {
	    my $f = int(int($i / ($d ** $j)) % $d);
	    push(@e, $b[$f]);
	}
	push(@c, [ @e ]);
    }
    return @c;
}

sub printcand {
    my (@c) = @_;
    @c = sort { $a cmp $b } @c;
    print ($c[0] . "\n");
    foreach my $i (1..$#c) {
	if($c[$i] !~ /$c[$i-1]/) {
	    print $c[$i] . "\n";
	}
    }
}
