#!/usr/local/bin/perl
# wget http://www.ring.gr.jp/archives/elisp/skk/dic/SKK-JISYO.itaiji.gz
# wget http://www.ring.gr.jp/archives/elisp/skk/dic/SKK-JISYO.itaiji.JIS3_4.gz
# gunzip SKK-JISYO.itaiji.gz SKK-JISYO.itaiji.JIS3_4.gz
# iconv -f EUC-JP -t UTF-8 < SKK-JISYO.itaiji > itaiji 
# iconv -f EUC-JISX0213 -t UTF-8 < SKK-JISYO.itaiji.JIS3_4 >> itaiji
# s2uitaiji.pl itaiji | sort | uniq > skk-itaiji.txt
#
   
use strict;
use open IN => ":utf8";
binmode STDOUT, ":utf8";

while(<>) {
    s/euc-jp/utf-8/;
    s/^;+.*$//;
    s/;[^\/]+\// /g;
    s/[\/]/ /g;
    s/\p{Hiragana}//g;
    s/\p{Katakana}//g;
    s/ +/ /g;
    s/^ //g;
    s/ $//g;
    s/^\p{Han}$//;
    if(/^\p{Han}/) {
	$_ = surt($_);
    }
    s/(\p{Han})/"U+". sprintf("%05X",ord($1))/eg;
    if(!/^$/) {
	print;
    }
}

sub surt {
    my ($c) = @_;
    my @x;
    s/(\p{Han})/push(@x, $1)/eg;
    @x = sort{$a cmp $b} @x;
    $c = ("" . $x[0]);
    foreach my $i (1..$#x) {
	if($x[$i]!~/$x[$i-1]/){
	    $c = ($c . " " . $x[$i]);
	}
    }
    return ($c . "\n");
}
